#version 430 core

uniform mat4 mvp;
uniform float time;

layout(location=0) in vec3 position;
layout(location=1) in vec3 normal;
layout(location=2) in vec3 tangent;
layout(location=3) in vec3 binormal;
layout(location=4) in vec2 texCoords;
layout(location=5) in vec2 texCoords2;
layout(location=6) in vec2 texCoords3;
layout(location=7) in vec2 texCoords4;
layout(location=8) in vec4 color;
layout(location=9) in vec4 color2;
//layout locations 10+ can be used for custom attriutes
out vec2 texCoordsVarying;
out vec4 colorVarying;
out vec3 posVarying;

void main() {
  vec4 col = color;
  vec3 pos = position;
  pos.y = sin(time*position.x) * 0.25+position.x;
  pos.x = cos(time*position.y) * 0.25+position.y;
  pos.z = sin(pos.y+time) * cos(pos.x+time) * 0.25 + position.z;
  texCoordsVarying = texCoords;
  if(dot(col,col) == 1)
    col = vec4(1,1,1,1);
  colorVarying = col;

  posVarying = pos;

  gl_Position = mvp * vec4(pos,1.0);

}
